# Zhi Xin 
# 4/11
import sys
import os
import subprocess
import string
import re
import commands

global idcFileName_manalysis
global idcFilename_callrelation
global ida32qFilePath
#global accountFilePath 
#global ida64qFilePath
#global ida64wFilePath


IDA=os.getenv("IDA")
ida32lFilePath = IDA + "idal" 
idcFileName_manalysis = "manalysiscl.idc"
idcFileName_callrelation = "callrelationcl.idc"
libcMappingPath = "/etc/lib_mapping"
ldlinuxFilePath = "/etc/ld-linux_syscalls"
#accountFilePath = "/home/zxin/Desktop/syscalblock/static_analysis/accountant/acct"

#######------functions--------------------------

def getDotSoFilePath (filename):
	pathsDotSoFile = []
	tmpLddStr = "ldd " + filename
	temp = commands.getoutput(tmpLddStr)
	lines = string.split(temp, '\n')
	for line in lines:
		path = string.split(line, ' ')
		if len(path) >= 3:
			pathsDotSoFile.append(path[2])
	return pathsDotSoFile

## Before run this funciton, please make sure several things have been done. 
## !!The mapping file between glibc library call and system calls "libc_mapping" is here
## !!The assistant program "acct" must be there.

def printSystemCalls (syscallset):
	print ''
	print '#-------the system call statistics-------#'
	for line in syscallset:
		print line

def collectSystemCalls (filename):
	# fill thei set from three spots
	syscallSet = [0 for x in range(350)]

        ##-----1.collect all the direct system calls--------
	exportEnvironCommand = 'export TVHEADLESS=1'
	os.system(exportEnvironCommand)
	callrelationCommand = ida32lFilePath + ' -A -S' + idcFileName_callrelation + ' ' + filename + '> /dev/null'
        
	print ''
	print '##-----------Start to analyze file ' + filename + '---------##'
	print '--------------section 1----------------- '
	os.system(callrelationCommand)
	print callrelationCommand

	# collect the direct system calls from return file "result"
	# the direct system calls can be extracted from the return file "result" with label "S"
	# For other entries, the content is supposed to be a function name. But for 'S', we set
	# the syscall number directly. 

	resFileName = filename + '_res'
	result_file  = open(resFileName,'r')
	result	     = result_file.readlines()
	for line in result:
		if line[0] == 'S':
			#print line
			line_item = string.split(line, ' ')
			syscallSet[int(line_item[1])] += 1

	result_file.close()
	#print "------------- after the 1 part analysis------------"
	#print ''.join(str(line) for line in syscallSet)

        ##-----2.collect all the dynamic linked libraries----
	print ''
        print '--------------section 2----------------- '
        tempPaths = getDotSoFilePath(filename)
        for path in tempPaths:
		# I'll analyze the libc first so we don't need to repeat every time.
   	       if os.path.exists(path) and path.find('libc.so.6') < 0:
       			print '# handle ' + path + ' recursively '
			cpSoCommand = 'cp ' + path + ' ./'
			os.system(cpSoCommand)
			trueSoName = path.split('/')
			# recursively call collectSystemCalls
			librarySystemCallSet = collectSystemCalls(str(trueSoName[-1]))
			# combine the library set with existing set
			setNum = 0
			for i in syscallSet:
				syscallSet[setNum] += librarySystemCallSet[setNum] 
				setNum += 1
	
	#print "------------- after the 2 part analysis------------"
	#print ''.join(str(line) for line in syscallSet)
                        
        ##-----3.collect extern function calls---------------
	print ''
        print '--------------section 3----------------- '
	manalysisCommand = ida32lFilePath + ' -A -S' + idcFileName_manalysis + ' ' + filename + '> /dev/null'
	print manalysisCommand
	os.system(manalysisCommand)

	#------The output file of "manalysis" is called result_extern.
	# And then, we utilize the "acct" script to generate the system calls from mapping between function and system calls.
	# There are supposed to have two files in current directory "xxx_res" and "xxx_ext"

	acctFileName = filename + '_ext'
        midFileName = 'syscalls' + '_' + filename + '_2' 
	acctSyscallCommand = 'acct s ' + acctFileName + ' > ' + midFileName
	os.system(acctSyscallCommand)
	print acctSyscallCommand

	#------When the process get here, the "syscalls" file is supposed to be generated
	#First, we read the syscalls file back to memory and count all the statistics
	#Then, we write the result back to file "xxxx_syscalls"
	syscalls_file  = open(midFileName, 'r')
	syscalls_lines = syscalls_file.readlines()

	lineNum = 0
	for number in syscalls_lines:
		#print 'The number in the syscalls file: ' + number
		syscallSet[lineNum] += int(number)
		lineNum += 1
	
	syscalls_file.close()		
	
	#print "------------- after the 3 part analysis------------"
	#print ''.join(str(line) for line in syscallSet)
	print ''
	print '--------------------section 4---------------------'
        ldlinux_file = open(ldlinuxFilePath, 'r')
	ldlinux_lines = ldlinux_file.readlines()

	lineNum = 0
	for number in ldlinux_lines:
		syscallSet[lineNum] += int(number)
		lineNum += 1
	ldlinux_file.close()
	#print "------------- after the 3 part analysis------------"
	#print ''.join(str(line) for line in syscallSet)
        ##-----4. return final set----------  
	return syscallSet

###########-------main--------------------#######-


if sys.argv < 3:
        print 'give me more input argument'

# all the system calls collected during the whole process should be placed here
syscallCollector = []

print ''
print '------ clean previous files----------'
targetFile = sys.argv[1]

removeFiles = 'rm ' + targetFile + '_res' + '; ' +  \
	      'rm ' + targetFile + '_ext' + '; ' +  \
	      'rm ' + targetFile + '_all' + '; ' +  \
	      'rm ' + targetFile + '_fun' + '; ' +  \
	      'rm ' + 'syscalls_' + targetFile + '_2'

os.system(removeFiles)
print removeFiles

# read every ELF file one by one 
#for targetFile in sys.argv[1:]:

syscallCollector = collectSystemCalls(targetFile)

	#printSystemCalls(syscallCollector)

#outputFileName = targetFile + '.syscall_block.log'
#output = open(outputFileName, 'wr')\
	# convert the list into a sequence of string

print ''
print "--------- the final result --------------"
outputStr = ""
# print the 1 & 0 sequence 
if sys.argv[2] == '-b':
	for line in syscallCollector:
		#print line
		if int(line) > 0:
			outputStr = outputStr + '0'
		else:
			outputStr = outputStr + '1' 
	
	print outputStr

	outputFileName = targetFile + '.syscall_block.log'
	output = open(outputFileName, 'wr')
	output.writelines(outputStr)
## print the count sequence
#elif sys.argv[2] == '-n':
#	outputStr = ''.join(str(line) for line in syscallCollector)
#	print outputStr
#	outputFileName = targetFile + '.syscall_block.log'
#	output = open(outputFileName, 'wr')
#	output.writelines(outputStr)
# print the multiple lines 
elif sys.argv[2] == '-a':
	print '-----data analysis purpose------'
	print syscallCollector
 	outputStr = "\n".join(str(line) for line in syscallCollector)
	outputFileName = targetFile + '_syscalls'
	output = open(outputFileName, 'wr')
	output.writelines(outputStr)
else:
	print '!!! error argument'


output.close()
print '#------- the whole process is over ----------#'
